﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Private CLV As CustomListView
	Private TouchedPiece As B4XView
	Private TouchedPanelCLVIndex, CLVOffset  As Int
	Private Panel1 As B4XView
	Type WorldPosition(x As Float, Y As Float)
	Private left, top, height, width As Float
	Private GestureDetector As GestureDetector
	Private PieceListOnBoard As Map
	
	Private difference As WorldPosition
	Private Label1 As B4XView
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	Label1.Rotation = -45
	
	PieceListOnBoard.Initialize

	GestureDetector.SetOnGestureListener(Panel1, "Panel1")

	For i = 1 To 16
		Private Panel As B4XView = xui.CreatePanel("Panel")
		Panel.SetLayoutAnimated(0, 0, 0, 80dip, 80dip)
		Panel.Color = Colors.RGB(Rnd(0, 256), Rnd(0, 256), Rnd(0, 256))
		
		Private text As Label
		text.Initialize("")
		text.Text = "Panel " & i
		text.TextSize = 16
		text.TextColor = Colors.White
		
		Panel.AddView(text, 0, 0, 80dip, 80dip)
		
		Panel.Tag = False
		
		CLV.Add(Panel, Panel)
	Next

	width = CLV.GetRawListItem(0).Panel.Width + CLV.DividerSize
	height = CLV.GetRawListItem(0).Panel.Height

End Sub

Private Sub Panel1_onTouch(Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Select Action
		Case 0 'down
			TouchedPiece = CheckTouchedPiece(X, Y)
			CLV.sv.Enabled = False	'When touch panel is held down, disable CLV gesture to avoid CLV scroll
		Case 1 'up
			TouchedPiece = Null
			CLV.sv.Enabled = True	'Enable CLV gesture when touch panel is released
	'		Panel1.BringToFront
		Case 2 'moving
			'	Nothing to see here
	End Select
	
	If Y >= Root.Height - height And Y <= Root.Height Then	Return GestureDetector.PassTouchEventTo(MotionEvent, CLV.sv)	'Pass touch event to clv if clv area is touched

	Return True
End Sub

Sub Panel1_onDrag(deltaX As Float, deltaY As Float, MotionEvent As Object)	
	If TouchedPiece.IsInitialized Then
		If TouchedPiece.Tag = False Then		'If piece is still in clv check if it's upward movement
			If  Abs(deltaY) > Abs(deltaX) And Abs(deltaY) > 5%y Then 	'If the gesture is more vertical than horizontal and covered more than the minimal distance (5%y)...
				RemovePieceFromCLV(left, top, TouchedPiece)
				MovePiece(MotionEvent)
			End If
		Else
			MovePiece(MotionEvent)
		End If
	End If
End Sub

Sub MovePiece(MotionEvent As Object)
	TouchedPiece.BringToFront
	TouchedPiece.Left = Max(0, Min(GestureDetector.getX(MotionEvent, 0) - difference.x, Root.Width - TouchedPiece.Width))
	TouchedPiece.top = Max(0, Min(GestureDetector.getY(MotionEvent, 0) - difference.y, Root.Height - TouchedPiece.Height))
	
	If GestureDetector.getY(MotionEvent, 0) >= Root.Height - height - 10dip And GestureDetector.getY(MotionEvent, 0) <= Root.Height Then
		If TouchedPiece.IsInitialized And TouchedPiece.Tag = True Then
			ReInsertPieceToCLV(GestureDetector.getX(MotionEvent, 0), GestureDetector.getY(MotionEvent, 0), TouchedPiece)
		End If
	End If
End Sub

Sub CheckTouchedPiece(x As Float, y As Float) As B4XView
	Private left1, left2 As Float
	
	If y >= Root.Height - height And y <= Root.Height Then 'If drag ocurs on custom list view area
		left1 = CLV.DividerSize
		x = x + CLVOffset
	
		For i = -1 To CLV.Size
			If left1 < x Then
				left1 = left1 + width
			Else
				left2 = left1 - CLV.DividerSize
				left1 = left1 - width
			
				If x >= left1 And x <= left2 Then
'					Log("Clicked Index is " & i)
					TouchedPanelCLVIndex = i
					left = left1
					top = Root.Height - height
	
					Private Panel As B4XView = CLV.GetPanel(TouchedPanelCLVIndex)
'					Panel.BringToFront
					
					Dim scale As Float = 20dip
					difference = GetWorldPosition(x - left + scale, y - top + scale)
	
					Return Panel
				End If
				Exit
			End If
		Next
		
	Else

		For Each PieceView As B4XView In PieceListOnBoard.Values
			If x > PieceView.Left And y > PieceView.Top And x < PieceView.Left + PieceView.Width And y < PieceView.Top + PieceView.Height Then
				Return PieceView
			End If			
		Next
	End If
	
	Return Null
End Sub

Sub ReInsertPieceToCLV(x As Float, y As Float, panel As B4XView)
	If panel.Tag = False Then 'false means it's part of CLV.
		Return
	End If
	
	Private left1, left2 As Float
	
	If y >= Root.Height - height And y <= Root.Height Then 'If drag ocurs on custom list view area
		left1 = CLV.DividerSize
		x = x + CLVOffset

		For i = -1 To CLV.Size
			If left1 < x Then
				left1 = left1 + width
			Else
				left2 = left1 - CLV.DividerSize
				left1 = left1 - width
			
				If x >= left1 And x <= left2 Then
'					Log("Piece will be inserted in Index " & i)
					TouchedPanelCLVIndex = i
					left = left1
					top = Root.Height - height
	
					panel.RemoveViewFromParent
					CLV.InsertAt(TouchedPanelCLVIndex, panel, panel)
					panel.Color = Colors.RGB(Rnd(0, 256), Rnd(0, 256), Rnd(0, 256))
					panel.Tag = False
					Log("Remove : " & TouchedPanelCLVIndex)
					PieceListOnBoard.Remove(TouchedPanelCLVIndex)	'Remove view from dragged out view list
				End If
				Exit
			End If
		Next
	End If

End Sub

Sub RemovePieceFromCLV(x As Float, y As Float, panel As B4XView)
	If panel.Tag = True Then 'true means already removed from CLV. False means still in CLV
		Return
	End If
	
	CLV.RemoveAt(TouchedPanelCLVIndex)
	panel.RemoveViewFromParent
	
	Root.AddView(panel, x, y, panel.Width, panel.Height)
	panel.Color = Colors.Black
	panel.Tag = True
	Log("Put : " & TouchedPanelCLVIndex)
	
	If PieceListOnBoard.ContainsKey(TouchedPanelCLVIndex) = False Then
		PieceListOnBoard.Put(TouchedPanelCLVIndex, panel) 'Add view to list of views that has been dragged out
	End If
End Sub

Private Sub CLV_ScrollChanged (Offset As Int)
	CLVOffset = Offset
End Sub

Sub GetWorldPosition(x As Float, y As Float) As WorldPosition
	Private position As WorldPosition
	position.Initialize
	
	position.x = x
	position.y = y
	
	Return position
End Sub